%{
#include <math.h>
#include <stdio.h>
#include "eva.h"
void yyerror(const char *s);
int yylex(void);
void print_val(double);
void quit(void);
%}
%union {
  double val;
  struct sym_def_struct *sym;
}

%token QUIT EVA ADAM
%token <val> NUM
%token <sym> VAR FNCT
%type  <val> exp
%right '='
%left '-' '+'
%left '*' '/'
%left NEG
%right '^'

%%
input:   /* empty */
        | input line
;

line:     '\n'
        | exp '\n'   { print_val($1);    }
        | exp ';'    { print_val($1);    }
        | error '\n' { yyerrok;          }
        | error ';'  { yyerrok;          }
        | QUIT       { quit();           }
        | EVA        { printf("Adam\n"); }
        | ADAM       { printf("Eva\n");  }
;

exp:      NUM                    { $$ = $1;                         }
        | VAR                    { $$ = $1->value.var;              }
        | VAR '=' exp            { $$ = $3; $1->value.var = $3;     }
        | FNCT '(' exp ')'       { $$ = (*($1->value.func))($3);    }
/*        | NFNCT '(' exp_list ')' { $$ = (*($1->value.func))($3);    }*/
        | exp '+' exp            { $$ = $1 + $3;                    }
        | exp '-' exp            { $$ = $1 - $3;                    }
        | exp '*' exp            { $$ = $1 * $3;                    }
        | exp '/' exp            { $$ = $1 / $3;                    }
        | '-' exp  %prec NEG     { $$ = -$2;                        }
        | exp '^' exp            { $$ = pow($1, $3);                }
        | '(' exp ')'            { $$ = $2;                         }
;

%%
